Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -5881,60 +12401,58 @@
 
         /*************************************************************************
-                      NONLINEAR BOUND CONSTRAINED OPTIMIZATION USING
-                              MODIFIED ACTIVE SET ALGORITHM
-                           WILLIAM W. HAGER AND HONGCHAO ZHANG
-
-        DESCRIPTION:
-        The  subroutine  minimizes  function  F(x)  of  N  arguments  with   bound
-        constraints: BndL[i] <= x[i] <= BndU[i]
-
-        This method is  globally  convergent  as  long  as  grad(f)  is  Lipschitz
-        continuous on a level set: L = { x : f(x)<=f(x0) }.
-
-
-        REQUIREMENTS:
-        Algorithm will request following information during its operation:
-        * function value F and its gradient G (simultaneously) at given point X
-
-
-        USAGE:
-        1. User initializes algorithm state with MinASACreate() call
-        2. User tunes solver parameters with MinASASetCond() MinASASetStpMax() and
-           other functions
-        3. User calls MinASAOptimize() function which takes algorithm  state   and
-           pointer (delegate, etc.) to callback function which calculates F/G.
-        4. User calls MinASAResults() to get solution
-        5. Optionally, user may call MinASARestartFrom() to solve another  problem
-           with same N but another starting point and/or another function.
-           MinASARestartFrom() allows to reuse already initialized structure.
-
-
-        INPUT PARAMETERS:
-            N       -   problem dimension, N>0:
-                        * if given, only leading N elements of X are used
-                        * if not given, automatically determined from sizes of
-                          X/BndL/BndU.
-            X       -   starting point, array[0..N-1].
-            BndL    -   lower bounds, array[0..N-1].
-                        all elements MUST be specified,  i.e.  all  variables  are
-                        bounded. However, if some (all) variables  are  unbounded,
-                        you may specify very small number as bound: -1000,  -1.0E6
-                        or -1.0E300, or something like that.
-            BndU    -   upper bounds, array[0..N-1].
-                        all elements MUST be specified,  i.e.  all  variables  are
-                        bounded. However, if some (all) variables  are  unbounded,
-                        you may specify very large number as bound: +1000,  +1.0E6
-                        or +1.0E300, or something like that.
-
-        OUTPUT PARAMETERS:
-            State   -   structure stores algorithm state
-
-        NOTES:
-
-        1. you may tune stopping conditions with MinASASetCond() function
-        2. if target function contains exp() or other fast growing functions,  and
-           optimization algorithm makes too large steps which leads  to  overflow,
-           use MinASASetStpMax() function to bound algorithm's steps.
-        3. this function does NOT support infinite/NaN values in X, BndL, BndU.
+        Obsolete function, use MinLBFGSSetPrecDefault() instead.
+
+          -- ALGLIB --
+             Copyright 13.10.2010 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlbfgssetdefaultpreconditioner(minlbfgs.minlbfgsstate state)
+        {
+            minlbfgs.minlbfgssetprecdefault(state);
+        }
+
+
+        /*************************************************************************
+        Obsolete function, use MinLBFGSSetCholeskyPreconditioner() instead.
+
+          -- ALGLIB --
+             Copyright 13.10.2010 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minlbfgssetcholeskypreconditioner(minlbfgs.minlbfgsstate state,
+            double[,] p,
+            bool isupper)
+        {
+            minlbfgs.minlbfgssetpreccholesky(state, p, isupper);
+        }
+
+
+        /*************************************************************************
+        This is obsolete function which was used by previous version of the  BLEIC
+        optimizer. It does nothing in the current version of BLEIC.
+
+          -- ALGLIB --
+             Copyright 28.11.2010 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minbleicsetbarrierwidth(minbleic.minbleicstate state,
+            double mu)
+        {
+        }
+
+
+        /*************************************************************************
+        This is obsolete function which was used by previous version of the  BLEIC
+        optimizer. It does nothing in the current version of BLEIC.
+
+          -- ALGLIB --
+             Copyright 28.11.2010 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minbleicsetbarrierdecay(minbleic.minbleicstate state,
+            double mudecay)
+        {
+        }
+
+
+        /*************************************************************************
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
@@ -5990,24 +12508,6 @@
 
         /*************************************************************************
-        This function sets stopping conditions for the ASA optimization algorithm.
-
-        INPUT PARAMETERS:
-            State   -   structure which stores algorithm state
-            EpsG    -   >=0
-                        The  subroutine  finishes  its  work   if   the  condition
-                        ||G||<EpsG is satisfied, where ||.|| means Euclidian norm,
-                        G - gradient.
-            EpsF    -   >=0
-                        The  subroutine  finishes  its work if on k+1-th iteration
-                        the  condition  |F(k+1)-F(k)|<=EpsF*max{|F(k)|,|F(k+1)|,1}
-                        is satisfied.
-            EpsX    -   >=0
-                        The subroutine finishes its work if  on  k+1-th  iteration
-                        the condition |X(k+1)-X(k)| <= EpsX is fulfilled.
-            MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
-                        iterations is unlimited.
-
-        Passing EpsG=0, EpsF=0, EpsX=0 and MaxIts=0 (simultaneously) will lead to
-        automatic stopping criterion selection (small EpsX).
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
@@ -6039,12 +12539,6 @@
 
         /*************************************************************************
-        This function turns on/off reporting.
-
-        INPUT PARAMETERS:
-            State   -   structure which stores algorithm state
-            NeedXRep-   whether iteration reports are needed or not
-
-        If NeedXRep is True, algorithm will call rep() callback function if  it is
-        provided to MinASAOptimize().
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
@@ -6059,12 +12553,6 @@
 
         /*************************************************************************
-        This function sets optimization algorithm.
-
-        INPUT PARAMETERS:
-            State   -   structure which stores algorithm stat
-            UAType  -   algorithm type:
-                        * -1    automatic selection of the best algorithm
-                        * 0     DY (Dai and Yuan) algorithm
-                        * 1     Hybrid DY-HS algorithm
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
@@ -6084,16 +12572,6 @@
 
         /*************************************************************************
-        This function sets maximum step length
-
-        INPUT PARAMETERS:
-            State   -   structure which stores algorithm state
-            StpMax  -   maximum step length, >=0. Set StpMax to 0.0,  if you don't
-                        want to limit step length (zero by default).
-
-        Use this subroutine when you optimize target function which contains exp()
-        or  other  fast  growing  functions,  and optimization algorithm makes too
-        large  steps  which  leads  to overflow. This function allows us to reject
-        steps  that  are  too  large  (and  therefore  expose  us  to the possible
-        overflow) without actually calculating function value at the x+stp*d.
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
@@ -6703,5 +13181,5 @@
                 state.stp = state.laststep;
             }
-            linmin.mcsrch(n, ref state.xn, ref state.f, ref state.gc, state.d, ref state.stp, state.stpmax, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
+            linmin.mcsrch(n, ref state.xn, ref state.f, ref state.gc, state.d, ref state.stp, state.stpmax, gtol, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
         lbl_51:
             if( state.mcstage==0 )
@@ -6744,5 +13222,5 @@
                 }
             }
-            linmin.mcsrch(n, ref state.xn, ref state.f, ref state.gc, state.d, ref state.stp, state.stpmax, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
+            linmin.mcsrch(n, ref state.xn, ref state.f, ref state.gc, state.d, ref state.stp, state.stpmax, gtol, ref mcinfo, ref state.nfev, ref state.work, state.lstate, ref state.mcstage);
             goto lbl_51;
         lbl_52:
@@ -7047,26 +13525,6 @@
 
         /*************************************************************************
-        ASA results
-
-        INPUT PARAMETERS:
-            State   -   algorithm state
-
-        OUTPUT PARAMETERS:
-            X       -   array[0..N-1], solution
-            Rep     -   optimization report:
-                        * Rep.TerminationType completetion code:
-                            * -2    rounding errors prevent further improvement.
-                                    X contains best point found.
-                            * -1    incorrect parameters were specified
-                            *  1    relative function improvement is no more than
-                                    EpsF.
-                            *  2    relative step is no more than EpsX.
-                            *  4    gradient norm is no more than EpsG
-                            *  5    MaxIts steps was taken
-                            *  7    stopping conditions are too stringent,
-                                    further improvement is impossible
-                        * Rep.IterationsCount contains iterations count
-                        * NFEV countains number of function calculations
-                        * ActiveConstraints contains number of active constraints
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
@@ -7084,10 +13542,6 @@
 
         /*************************************************************************
-        ASA results
-
-        Buffered implementation of MinASAResults() which uses pre-allocated buffer
-        to store X[]. If buffer size is  too  small,  it  resizes  buffer.  It  is
-        intended to be used in the inner cycles of performance critical algorithms
-        where array reallocation penalty is too large to be ignored.
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
@@ -7124,15 +13578,6 @@
 
         /*************************************************************************
-        This  subroutine  restarts  CG  algorithm from new point. All optimization
-        parameters are left unchanged.
-
-        This  function  allows  to  solve multiple  optimization  problems  (which
-        must have same number of dimensions) without object reallocation penalty.
-
-        INPUT PARAMETERS:
-            State   -   structure previously allocated with MinCGCreate call.
-            X       -   new starting point.
-            BndL    -   new lower bounds
-            BndU    -   new upper bounds
+        Obsolete optimization algorithm.
+        Was replaced by MinBLEIC subpackage.
 
           -- ALGLIB --
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/specialfunctions.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/specialfunctions.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/specialfunctions.cs	(revision 7294)
@@ -790,508 +790,4 @@
 
     /*************************************************************************
-    Calculation of the value of the Chebyshev polynomials of the
-    first and second kinds.
-
-    Parameters:
-        r   -   polynomial kind, either 1 or 2.
-        n   -   degree, n>=0
-        x   -   argument, -1 <= x <= 1
-
-    Result:
-        the value of the Chebyshev polynomial at x
-    *************************************************************************/
-    public static double chebyshevcalculate(int r, int n, double x)
-    {
-
-        double result = chebyshev.chebyshevcalculate(r, n, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Summation of Chebyshev polynomials using Clenshaws recurrence formula.
-
-    This routine calculates
-        c[0]*T0(x) + c[1]*T1(x) + ... + c[N]*TN(x)
-    or
-        c[0]*U0(x) + c[1]*U1(x) + ... + c[N]*UN(x)
-    depending on the R.
-
-    Parameters:
-        r   -   polynomial kind, either 1 or 2.
-        n   -   degree, n>=0
-        x   -   argument
-
-    Result:
-        the value of the Chebyshev polynomial at x
-    *************************************************************************/
-    public static double chebyshevsum(double[] c, int r, int n, double x)
-    {
-
-        double result = chebyshev.chebyshevsum(c, r, n, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Representation of Tn as C[0] + C[1]*X + ... + C[N]*X^N
-
-    Input parameters:
-        N   -   polynomial degree, n>=0
-
-    Output parameters:
-        C   -   coefficients
-    *************************************************************************/
-    public static void chebyshevcoefficients(int n, out double[] c)
-    {
-        c = new double[0];
-        chebyshev.chebyshevcoefficients(n, ref c);
-        return;
-    }
-
-    /*************************************************************************
-    Conversion of a series of Chebyshev polynomials to a power series.
-
-    Represents A[0]*T0(x) + A[1]*T1(x) + ... + A[N]*Tn(x) as
-    B[0] + B[1]*X + ... + B[N]*X^N.
-
-    Input parameters:
-        A   -   Chebyshev series coefficients
-        N   -   degree, N>=0
-
-    Output parameters
-        B   -   power series coefficients
-    *************************************************************************/
-    public static void fromchebyshev(double[] a, int n, out double[] b)
-    {
-        b = new double[0];
-        chebyshev.fromchebyshev(a, n, ref b);
-        return;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Dawson's Integral
-
-    Approximates the integral
-
-                                x
-                                -
-                         2     | |        2
-     dawsn(x)  =  exp( -x  )   |    exp( t  ) dt
-                             | |
-                              -
-                              0
-
-    Three different rational approximations are employed, for
-    the intervals 0 to 3.25; 3.25 to 6.25; and 6.25 up.
-
-    ACCURACY:
-
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE      0,10        10000       6.9e-16     1.0e-16
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1989, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double dawsonintegral(double x)
-    {
-
-        double result = dawson.dawsonintegral(x);
-        return result;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Complete elliptic integral of the first kind
-
-    Approximates the integral
-
-
-
-               pi/2
-                -
-               | |
-               |           dt
-    K(m)  =    |    ------------------
-               |                   2
-             | |    sqrt( 1 - m sin t )
-              -
-               0
-
-    using the approximation
-
-        P(x)  -  log x Q(x).
-
-    ACCURACY:
-
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE       0,1        30000       2.5e-16     6.8e-17
-
-    Cephes Math Library, Release 2.8:  June, 2000
-    Copyright 1984, 1987, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double ellipticintegralk(double m)
-    {
-
-        double result = elliptic.ellipticintegralk(m);
-        return result;
-    }
-
-    /*************************************************************************
-    Complete elliptic integral of the first kind
-
-    Approximates the integral
-
-
-
-               pi/2
-                -
-               | |
-               |           dt
-    K(m)  =    |    ------------------
-               |                   2
-             | |    sqrt( 1 - m sin t )
-              -
-               0
-
-    where m = 1 - m1, using the approximation
-
-        P(x)  -  log x Q(x).
-
-    The argument m1 is used rather than m so that the logarithmic
-    singularity at m = 1 will be shifted to the origin; this
-    preserves maximum accuracy.
-
-    K(0) = pi/2.
-
-    ACCURACY:
-
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE       0,1        30000       2.5e-16     6.8e-17
-
-    Àëãîðèòì âçÿò èç áèáëèîòåêè Cephes
-    *************************************************************************/
-    public static double ellipticintegralkhighprecision(double m1)
-    {
-
-        double result = elliptic.ellipticintegralkhighprecision(m1);
-        return result;
-    }
-
-    /*************************************************************************
-    Incomplete elliptic integral of the first kind F(phi|m)
-
-    Approximates the integral
-
-
-
-                   phi
-                    -
-                   | |
-                   |           dt
-    F(phi_\m)  =    |    ------------------
-                   |                   2
-                 | |    sqrt( 1 - m sin t )
-                  -
-                   0
-
-    of amplitude phi and modulus m, using the arithmetic -
-    geometric mean algorithm.
-
-
-
-
-    ACCURACY:
-
-    Tested at random points with m in [0, 1] and phi as indicated.
-
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE     -10,10       200000      7.4e-16     1.0e-16
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double incompleteellipticintegralk(double phi, double m)
-    {
-
-        double result = elliptic.incompleteellipticintegralk(phi, m);
-        return result;
-    }
-
-    /*************************************************************************
-    Complete elliptic integral of the second kind
-
-    Approximates the integral
-
-
-               pi/2
-                -
-               | |                 2
-    E(m)  =    |    sqrt( 1 - m sin t ) dt
-             | |
-              -
-               0
-
-    using the approximation
-
-         P(x)  -  x log x Q(x).
-
-    ACCURACY:
-
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE       0, 1       10000       2.1e-16     7.3e-17
-
-    Cephes Math Library, Release 2.8: June, 2000
-    Copyright 1984, 1987, 1989, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double ellipticintegrale(double m)
-    {
-
-        double result = elliptic.ellipticintegrale(m);
-        return result;
-    }
-
-    /*************************************************************************
-    Incomplete elliptic integral of the second kind
-
-    Approximates the integral
-
-
-                   phi
-                    -
-                   | |
-                   |                   2
-    E(phi_\m)  =    |    sqrt( 1 - m sin t ) dt
-                   |
-                 | |
-                  -
-                   0
-
-    of amplitude phi and modulus m, using the arithmetic -
-    geometric mean algorithm.
-
-    ACCURACY:
-
-    Tested at random arguments with phi in [-10, 10] and m in
-    [0, 1].
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE     -10,10      150000       3.3e-15     1.4e-16
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1993, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double incompleteellipticintegrale(double phi, double m)
-    {
-
-        double result = elliptic.incompleteellipticintegrale(phi, m);
-        return result;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Exponential integral Ei(x)
-
-                  x
-                   -     t
-                  | |   e
-       Ei(x) =   -|-   ---  dt .
-                | |     t
-                 -
-                -inf
-
-    Not defined for x <= 0.
-    See also expn.c.
-
-
-
-    ACCURACY:
-
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE       0,100       50000      8.6e-16     1.3e-16
-
-    Cephes Math Library Release 2.8:  May, 1999
-    Copyright 1999 by Stephen L. Moshier
-    *************************************************************************/
-    public static double exponentialintegralei(double x)
-    {
-
-        double result = expintegrals.exponentialintegralei(x);
-        return result;
-    }
-
-    /*************************************************************************
-    Exponential integral En(x)
-
-    Evaluates the exponential integral
-
-                    inf.
-                      -
-                     | |   -xt
-                     |    e
-         E (x)  =    |    ----  dt.
-          n          |      n
-                   | |     t
-                    -
-                     1
-
-
-    Both n and x must be nonnegative.
-
-    The routine employs either a power series, a continued
-    fraction, or an asymptotic formula depending on the
-    relative values of n and x.
-
-    ACCURACY:
-
-                         Relative error:
-    arithmetic   domain     # trials      peak         rms
-       IEEE      0, 30       10000       1.7e-15     3.6e-16
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1985, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static double exponentialintegralen(double x, int n)
-    {
-
-        double result = expintegrals.exponentialintegralen(x, n);
-        return result;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Fresnel integral
-
-    Evaluates the Fresnel integrals
-
-              x
-              -
-             | |
-    C(x) =   |   cos(pi/2 t**2) dt,
-           | |
-            -
-             0
-
-              x
-              -
-             | |
-    S(x) =   |   sin(pi/2 t**2) dt.
-           | |
-            -
-             0
-
-
-    The integrals are evaluated by a power series for x < 1.
-    For x >= 1 auxiliary functions f(x) and g(x) are employed
-    such that
-
-    C(x) = 0.5 + f(x) sin( pi/2 x**2 ) - g(x) cos( pi/2 x**2 )
-    S(x) = 0.5 - f(x) cos( pi/2 x**2 ) - g(x) sin( pi/2 x**2 )
-
-
-
-    ACCURACY:
-
-     Relative error.
-
-    Arithmetic  function   domain     # trials      peak         rms
-      IEEE       S(x)      0, 10       10000       2.0e-15     3.2e-16
-      IEEE       C(x)      0, 10       10000       1.8e-15     3.3e-16
-
-    Cephes Math Library Release 2.8:  June, 2000
-    Copyright 1984, 1987, 1989, 2000 by Stephen L. Moshier
-    *************************************************************************/
-    public static void fresnelintegral(double x, ref double c, ref double s)
-    {
-
-        fresnel.fresnelintegral(x, ref c, ref s);
-        return;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
-    Calculation of the value of the Hermite polynomial.
-
-    Parameters:
-        n   -   degree, n>=0
-        x   -   argument
-
-    Result:
-        the value of the Hermite polynomial Hn at x
-    *************************************************************************/
-    public static double hermitecalculate(int n, double x)
-    {
-
-        double result = hermite.hermitecalculate(n, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Summation of Hermite polynomials using Clenshaws recurrence formula.
-
-    This routine calculates
-        c[0]*H0(x) + c[1]*H1(x) + ... + c[N]*HN(x)
-
-    Parameters:
-        n   -   degree, n>=0
-        x   -   argument
-
-    Result:
-        the value of the Hermite polynomial at x
-    *************************************************************************/
-    public static double hermitesum(double[] c, int n, double x)
-    {
-
-        double result = hermite.hermitesum(c, n, x);
-        return result;
-    }
-
-    /*************************************************************************
-    Representation of Hn as C[0] + C[1]*X + ... + C[N]*X^N
-
-    Input parameters:
-        N   -   polynomial degree, n>=0
-
-    Output parameters:
-        C   -   coefficients
-    *************************************************************************/
-    public static void hermitecoefficients(int n, out double[] c)
-    {
-        c = new double[0];
-        hermite.hermitecoefficients(n, ref c);
-        return;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
     Incomplete beta integral
 
